net.sf.cpsolver.coursett.constraint

## Class JenrlConstraint

- java.lang.Object
- - net.sf.cpsolver.ifs.model.Constraint<V,T>
  - - net.sf.cpsolver.ifs.model.BinaryConstraint<Lecture,Placement>
    - - net.sf.cpsolver.coursett.constraint.JenrlConstraint

- All Implemented Interfaces:
    Comparable<Constraint<Lecture,Placement>>, WeakeningConstraint<Lecture,Placement>

      public class JenrlConstraint
      extends BinaryConstraint<Lecture,Placement>
      implements WeakeningConstraint<Lecture,Placement>

  Join student enrollment constraint.
  This constraint is placed between all pairs of classes where there is at least one student attending both classes. It represents a number of student conflicts (number of joined enrollments), if the given two classes overlap in time.
  Also, it dynamically maintains the counter of all student conflicts. It is a soft constraint.
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.ifs.model.Constraint

      `iAssignedVariables, iConstraintListeners, iId`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JenrlConstraint()` Constructor

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addVariable(Lecture variable)` Add a variable to this constraint
    `boolean` | `areStudentConflictsCommitted()`
    `boolean` | `areStudentConflictsDistance()`
    `boolean` | `areStudentConflictsDistance(Placement value)`
    `boolean` | `areStudentConflictsHard()`
    `void` | `assigned(long iteration, Placement value)` Given value is to be assigned to its varable.
    `void` | `computeConflicts(Placement value, Set<Placement> conflicts)` The only method which has to be implemented by any constraint.
    `void` | `decJenrl(Student student)` Decrement the number of joined enrollments (during student final sectioning)
    `Set<Student>` | `getInstructors()`
    `long` | `getJenrl()` Number of joined enrollments (during student final sectioning)
    `double` | `getJenrlWeight(Student student)`
    `String` | `getName()` Constraint's name -- for printing purposes
    `int` | `getNrInstructors()`
    `int` | `getNrStudents()`
    `Set<Student>` | `getStudents()`
    `void` | `incJenrl(Student student)` Increment the number of joined enrollments (during student final sectioning)
    `boolean` | `inConflict(Placement value)` Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint.
    `boolean` | `isConsistent(Placement value1, Placement value2)` Returns true if the given assignments are consistent respecting this constraint.
    `boolean` | `isHard()` Returns true if the constraint is hard.
    `boolean` | `isInConflict()` True if the given two lectures overlap in time
    `static boolean` | `isInConflict(Placement p1, Placement p2, DistanceMetric m)` Returns true if the given placements are overlapping or they are back-to-back and too far for students.
    `boolean` | `isOfTheSameProblem()`
    `boolean` | `isOverLimit()`
    `boolean` | `isToBeIgnored()` Returns true if there is `IgnoreStudentConflictsConstraint` between the two lectures.
    `double` | `jenrl()`
    `long` | `jenrl(Lecture variable, Placement value)` Number of joined enrollments if the given value is assigned to the given variable
    `double` | `priority()`
    `String` | `toString()`
    `void` | `unassigned(long iteration, Placement value)` Given value is unassigned from its variable.
    `void` | `weaken()` Weaken the constraint.
    `void` | `weaken(Placement value)` Weaken the constraint enough so that it can assign the given value.

    - ### Methods inherited from class net.sf.cpsolver.ifs.model.BinaryConstraint

      `another, first, isFirst, second`

    - ### Methods inherited from class net.sf.cpsolver.ifs.model.Constraint

      `addConstraintListener, assignedVariables, compareTo, constraintListeners, countAssignedVariables, countVariables, equals, getDescription, getId, getModel, hashCode, removeConstraintListener, removeVariable, setModel, variables`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### JenrlConstraint

          public JenrlConstraint()

      Constructor

  - ### Method Detail

    - #### addVariable

          public void addVariable(Lecture variable)

      Description copied from class: `Constraint`
      Add a variable to this constraint
      Overrides:
        `addVariable` in class `BinaryConstraint<Lecture,Placement>`

    - #### computeConflicts

          public void computeConflicts(Placement value,
                                       Set<Placement> conflicts)

      Description copied from class: `Constraint`
      The only method which has to be implemented by any constraint. It returns the values which needs to be unassigned in order to make this constraint consistent with the given value if it is assigned to its variable. The computed list of conflicting values is added to the given set of conflicts.
      Specified by:
        `computeConflicts` in class `Constraint<Lecture,Placement>`
      Parameters:
        `value` - value to be assigned to its varaible
        `conflicts` - resultant set of conflicting values

    - #### inConflict

          public boolean inConflict(Placement value)

      Description copied from class: `Constraint`
      Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `inConflict` in class `Constraint<Lecture,Placement>`

    - #### isConsistent

          public boolean isConsistent(Placement value1,
                                      Placement value2)

      Description copied from class: `Constraint`
      Returns true if the given assignments are consistent respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `isConsistent` in class `Constraint<Lecture,Placement>`

    - #### unassigned

          public void unassigned(long iteration,
                                 Placement value)

      Description copied from class: `Constraint`
      Given value is unassigned from its variable.
      Overrides:
        `unassigned` in class `Constraint<Lecture,Placement>`

    - #### isInConflict

          public static boolean isInConflict(Placement p1,
                                             Placement p2,
                                             DistanceMetric m)

      Returns true if the given placements are overlapping or they are back-to-back and too far for students.

    - #### assigned

          public void assigned(long iteration,
                               Placement value)

      Description copied from class: `Constraint`
      Given value is to be assigned to its varable. In this method, the constraint should unassigns all varaibles which are in conflict with the given assignment because of this constraint.
      Overrides:
        `assigned` in class `Constraint<Lecture,Placement>`

    - #### jenrl

          public long jenrl(Lecture variable,
                            Placement value)

      Number of joined enrollments if the given value is assigned to the given variable

    - #### isInConflict

          public boolean isInConflict()

      True if the given two lectures overlap in time

    - #### incJenrl

          public void incJenrl(Student student)

      Increment the number of joined enrollments (during student final sectioning)

    - #### getJenrlWeight

          public double getJenrlWeight(Student student)

    - #### decJenrl

          public void decJenrl(Student student)

      Decrement the number of joined enrollments (during student final sectioning)

    - #### getJenrl

          public long getJenrl()

      Number of joined enrollments (during student final sectioning)

    - #### jenrl

          public double jenrl()

    - #### priority

          public double priority()

    - #### getNrStudents

          public int getNrStudents()

    - #### getStudents

          public Set<Student> getStudents()

    - #### getNrInstructors

          public int getNrInstructors()

    - #### getInstructors

          public Set<Student> getInstructors()

    - #### isHard

          public boolean isHard()

      Description copied from class: `Constraint`
      Returns true if the constraint is hard. Only hard constraints are allowed to unassign a variable when there is a conflict with a value that is being assigned
      Overrides:
        `isHard` in class `Constraint<Lecture,Placement>`

    - #### isOverLimit

          public boolean isOverLimit()

    - #### getName

          public String getName()

      Description copied from class: `Constraint`
      Constraint's name -- for printing purposes
      Overrides:
        `getName` in class `Constraint<Lecture,Placement>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### areStudentConflictsHard

          public boolean areStudentConflictsHard()

    - #### areStudentConflictsDistance

          public boolean areStudentConflictsDistance()

    - #### areStudentConflictsCommitted

          public boolean areStudentConflictsCommitted()

    - #### areStudentConflictsDistance

          public boolean areStudentConflictsDistance(Placement value)

    - #### isOfTheSameProblem

          public boolean isOfTheSameProblem()

    - #### weaken

          public void weaken()

      Description copied from interface: `WeakeningConstraint`
      Weaken the constraint. This method is called if the constraint participates in an unassigned of a variable.
      Specified by:
        `weaken` in interface `WeakeningConstraint<Lecture,Placement>`

    - #### weaken

          public void weaken(Placement value)

      Description copied from interface: `WeakeningConstraint`
      Weaken the constraint enough so that it can assign the given value.
      Specified by:
        `weaken` in interface `WeakeningConstraint<Lecture,Placement>`

    - #### isToBeIgnored

          public boolean isToBeIgnored()

      Returns true if there is `IgnoreStudentConflictsConstraint` between the two lectures.